> ## Documentation Index
> Fetch the complete documentation index at: https://docs.retab.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Download Table CSV

Download the CSV backing a table.

<RequestExample>
  ```python Python theme={null}
  from retab import Retab

  client = Retab()

  csv_bytes = client.tables.download(table_id="workflow_table_123")
  print(len(csv_bytes))
  ```

  ```typescript TypeScript theme={null}
  import { Retab } from "@retab/node";

  const client = new Retab({ apiKey: process.env.RETAB_API_KEY });

  const csv = await client.tables.download("workflow_table_123");
  console.log(csv.size);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"log"

  	retab "github.com/retab-dev/retab/clients/go"
  )

  func main() {
  	ctx := context.Background()

  	client, err := retab.NewClient("")
  	if err != nil {
  		log.Fatal(err)
  	}

  	if err := client.Tables.Download(ctx, "workflow_table_123"); err != nil {
  		log.Fatal(err)
  	}
  }
  ```

  ```ruby Ruby theme={null}
  require 'retab'

  client = Retab::Client.new(api_key: ENV['RETAB_API_KEY'])

  csv = client.tables.download(table_id: 'workflow_table_123')
  puts csv
  ```

  ```rust Rust theme={null}
  use retab::Retab;

  #[tokio::main]
  async fn main() -> Result<(), Box<dyn std::error::Error>> {
      let client = Retab::new(std::env::var("RETAB_API_KEY")?);

      let csv = client.tables().download("workflow_table_123").await?;
      println!("{} bytes", csv.len());
      Ok(())
  }
  ```

  ```php PHP theme={null}
  <?php
  require 'vendor/autoload.php';

  use Retab\Client;

  $client = new Client(apiKey: getenv('RETAB_API_KEY'));

  $result = $client->tables()->download(
      tableId: 'workflow_table_123',
  );
  print_r($result);
  ```

  ```csharp C# theme={null}
  using Retab;
  using RetabClient = Retab.Retab;

  var apiKey = Environment.GetEnvironmentVariable("RETAB_API_KEY")!;
  var client = new RetabClient(apiKey);

  await client.Tables.DownloadAsync("workflow_table_123");
  ```

  ```java Java theme={null}
  import com.retab.RetabClient;

  public final class Example {
    public static void main(String[] args) throws Exception {
      RetabClient client = new RetabClient(System.getenv("RETAB_API_KEY"));

      var result = client.tables().download("workflow_table_123");
      System.out.println(result);
    }
  }
  ```

  ```bash cURL theme={null}
  curl https://api.retab.com/v1/tables/workflow_table_123/download \
    -H "Authorization: Bearer $RETAB_API_KEY" \
    -o carriers.csv
  ```
</RequestExample>


## OpenAPI

````yaml GET /v1/tables/{table_id}/download
openapi: 3.1.0
info:
  title: FastAPI
  version: 0.1.0
servers:
  - url: https://api.retab.com
security: []
paths:
  /v1/tables/{table_id}/download:
    get:
      tags:
        - Tables
      summary: Table.Download
      operationId: download_table_csv
      parameters:
        - in: path
          name: table_id
          required: true
          schema:
            type: string
            title: Table Id
      responses:
        '200':
          description: Successful Response
          content:
            text/csv:
              schema:
                type: string
                format: binary
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
          default: []
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
          default: null
        ctx:
          type: object
          title: Context
          default: {}
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````